local Tunnel = module("vrp", "lib/Tunnel")
local Proxy = module("vrp", "lib/Proxy")
cfg = module("vrp", "cfg/factions")

vRP = Proxy.getInterface("vRP")
vRPclient = Tunnel.getInterface("vRP", "vRP_turfs")
vRPCturfs = Tunnel.getInterface("vRP_turfs", "vRP_turfs")

vRPSturfs = {}
Tunnel.bindInterface("vRP_turfs", vRPSturfs)

turfs = {}
alreadyExecuted = {}
inWar = {}
turfWars = {}
lastAttacked = {}

function vRPSturfs.spawnTurfs()
  turfs = {}
  exports[plesTurfs.databaseDriver]:execute("SELECT * FROM " .. plesTurfs.database, {}, function(rows)
      if #rows > 0 then
          for k, v in pairs(rows) do
              local id, x, y, z, blipRadius, faction = v.id, v.x, v.y, v.z, v.blipRadius, v.faction
              local blipColor = vRP.getFactionBlip({faction})
              turfs[id] = {x = x, y = y, z = z, blipRadius = blipRadius, blipColor = blipColor, faction = faction}
              vRPCturfs.spawnTheTurfs(-1, {id, x, y, z, blipColor, blipRadius, faction})
          end
      end
  end)
end

function vRPSturfs.spawnTurfsC(player)
  for id, data in pairs(turfs) do
      vRPCturfs.spawnTheTurfs(player, {id, data.x, data.y, data.z, data.blipColor, data.blipRadius, data.faction})
  end
end

function drawInfoText(player, allyFaction, enemyFaction, allyScore, enemyScore, minute, secunde, turfId)-- pentru comanda /wars
  TriggerClientEvent(plesTurfs.chatEvent, player, '----------> Scor War ^1#' .. turfId .. ' <----------')
  TriggerClientEvent(plesTurfs.chatEvent, player, '> Scor ^1' .. allyFaction .. '^0: ^2' .. allyScore)
  TriggerClientEvent(plesTurfs.chatEvent, player, '> Scor ^1' .. enemyFaction .. '^0: ^2' .. enemyScore)
  TriggerClientEvent(plesTurfs.chatEvent, player, string.format('Timp Ramas: ^2%02d:%02d', minute, secunde))
end

function isWarInThisDay(day)
  for k, v in pairs(plesTurfs.Days) do
      if day == v then
          return true
      end
  end
  return false
end

Citizen.CreateThread(function()
  while true do
      if not isWarInThisDay(tostring(os.date("%A"))) then
          Citizen.Wait(3600000)
      else
          while parseInt(os.date("%H")) >= plesTurfs.StartingHour and parseInt(os.date("%H")) <= plesTurfs.EndingHour do
              for k, v in pairs(turfWars) do
                  if v.timer then
                      local turfID = k
                      
                      local players = v.warPlayers
                      
                      local minute = v.timer[1]
                      local secunde = v.timer[2]
                      secunde = secunde - 1
                      if secunde <= 0 then
                          secunde = 59
                          minute = minute - 1
                      end
                      
                      for _, data in pairs(players) do
                          local player = data.player
                          if player then
                              vRPCturfs.updateTime(player, {minute, secunde})
                          end
                      end
                      
                      if minute < 0 then
                        turfWars[turfID].timer = nil
                        endTurf(turfID)
                      else
                          turfWars[turfID].timer = {
                              minute, secunde
                          }
                      end
                  end
              end
              Citizen.Wait(1000)
          end
      end
      Citizen.Wait(60000)
  end
end)

function startTimer(min, sec, turfID)
  if turfWars[turfID].timer then return end
  turfWars[turfID].timer = {tonumber(min), tonumber(sec)}
end

RegisterCommand("createTurf", function(player)
  local user_id = vRP.getUserId({player})
  if user_id then
      local isAdmin = vRP.isUserFondator({user_id})
      if isAdmin then 
          vRP.prompt({player, "Creeaza Turf", "Te rugam sa introduci raza turfului pe care vrei sa-l creezi.", function(player, radius)
              if radius ~= nil and radius ~= "" and tonumber(radius) then
                  local radius = parseFloat(radius)
                  local ped = GetPlayerPed(player)
                  local coords = GetEntityCoords(ped)
                  exports[plesTurfs.databaseDriver]:execute("INSERT INTO vrp_turfs(x, y, z, faction, blipRadius) VALUES(@x, @y, @z, 'Neocupat', @radius)", {
                      x = coords.x,
                      y = coords.y,
                      z = coords.z,
                      radius = radius
                  }, function(rows)
                      if rows.affectedRows > 0 then
                          local turfId = rows.insertId
                          TriggerClientEvent("chatMessage", -1, "Administratorul ^4"..GetPlayerName(player).."("..user_id..")^0 a creeat turf-ul cu ^4id-ul "..turfId.."^0.")
                      end
                  end)
              else
                  vRPclient.notify(player, {"Raza specificata este invalida."})
              end
          end})
      else
          vRPclient.notify(player, {"Info: Nu ai acces la aceasta comanda!"})
      end
  end
end)

RegisterCommand("turfs", function(player)
  vRPCturfs.showTheTurfs(player)
end)

RegisterCommand("borders", function(player)
  vRPCturfs.showBorders(player)
end)

RegisterCommand("cancelattack", function(player)
  local user_id = vRP.getUserId{player}
  vRPCturfs.saTiIauMortiiInPulaDeScript(player, {}, function(turfID)
      if turfID then
          local faction = vRP.getUserFaction({user_id})
          if turfWars[turfID].enemyFaction == faction then
              cancelAttack(turfID)
          else
              vRPclient.notify(player, {plesTurfs.LangNotAttacker})
          end
      else
          vRPclient.notify(player, {plesTurfs.LangNotInWar})
      end
  end)
end)

RegisterCommand("wars", function(player)
  local user_id = vRP.getUserId{player}
  if user_id then
      for key, value in pairs(turfWars) do
          if value.enemyFaction and value.allyFaction then
              drawInfoText(player, value.allyFaction, value.enemyFaction, value.allyScore, value.enemyScore, turfWars[key].timer[1], turfWars[key].timer[2], key)
          end
      end
  end
end)

RegisterCommand("getlocaltime", function(player)
  if player == 0 then
      local ora = parseInt(os.date("%H"))
      
      print(("%02d"):format(os.date("%H")) .. " / ORA EXACTA A SERVER-ULUI - " .. os.date("%d/%m/%Y %H:%M", os.time()) .. " / DATA EXACTA A SERVERULUI")
  else
      TriggerClientEvent("chatMessage", player, "Nu e frumos sa vrei sa folosesti asemenea comanda, nu crezi?")
  end
end)

CreateThread(function()
  vRPSturfs.spawnTurfs()
  local users = vRP.getUsers({})
  for k, v in pairs(users) do
      alreadyExecuted[v] = nil
  end
end)

RegisterCommand("sh", function(player)
  if player == 0 then
      vRPSturfs.spawnTurfs()
      local users = vRP.getUsers({})
      for k, v in pairs(users) do
          alreadyExecuted[v] = nil
      end
  else
      TriggerClientEvent("chatMessage", player, "Nu e frumos sa vrei sa folosesti asemenea comanda, nu crezi?")
  end
end)

function cancelAttack(turfId)
  if turfWars[turfId].allyScore == 0 and turfWars[turfId].enemyScore == 0 then
    for _, data in pairs(turfWars[turfId].warPlayers) do
      local player = data.player
      if player then
        TriggerEvent("pma-voice:updateVirtualWorld", player, 0)
        Player(player).state.turf_kills = 0;
        Player(player).state.turf_deaths = 0;
        vRPCturfs.endTurfWar(player, {turfId})
        vRPCturfs.setInTheTurf(player, {false})
        SetPlayerRoutingBucket(player, 0)
      end
    end
    vRPCturfs.stopFlick(-1, {turfId})
    vRPCturfs.updateData(-1, {turfId, turfs[turfId].blipColor})
    --lastAttacked[turfWars[turfId].enemyFaction] = nil
    lastAttacked[turfWars[turfId].enemyFaction] = os.time()
    print(os.time())
    inWar[turfWars[turfId].allyFaction] = nil
    inWar[turfWars[turfId].enemyFaction] = nil
    turfWars[turfId] = nil
  end
end

function endTurf(turfId)
  Wait(500)
  local winner
  if turfWars[turfId].allyScore > turfWars[turfId].enemyScore then
    TriggerClientEvent(plesTurfs.chatEvent, -1, string.format(plesTurfs.LangWarEnd, turfWars[turfId].allyFaction, turfWars[turfId].enemyFaction, turfId, turfWars[turfId].allyFaction))
    winner = turfWars[turfId].allyFaction
  elseif turfWars[turfId].allyScore <= turfWars[turfId].enemyScore then
    TriggerClientEvent(plesTurfs.chatEvent, -1, string.format(plesTurfs.LangWarEnd, turfWars[turfId].allyFaction, turfWars[turfId].enemyFaction, turfId, turfWars[turfId].enemyFaction))
    exports[plesTurfs.databaseDriver]:execute("UPDATE " .. plesTurfs.database .. " SET faction = @faction WHERE id = @turfId", {
      ["@turfId"] = turfId,
      ["@faction"] = turfWars[turfId].enemyFaction
    })
    winner = turfWars[turfId].enemyFaction
  elseif turfWars[turfId].allyScore == turfWars[turfId].enemyScore then
    TriggerClientEvent(plesTurfs.chatEvent, -1, string.format(plesTurfs.LangWarEnd, turfWars[turfId].allyFaction, turfWars[turfId].enemyFaction, turfId, turfWars[turfId].allyFaction))
    winner = turfWars[turfId].allyFaction
  end
  TriggerClientEvent(plesTurfs.chatEvent, -1, string.format(plesTurfs.LangScore, math.floor(turfWars[turfId].enemyScore), turfWars[turfId].enemyFaction, math.floor(turfWars[turfId].allyScore), turfWars[turfId].allyFaction))
  for _, data in pairs(turfWars[turfId].warPlayers) do
    local player = data.player
    if player then
      -- TriggerClientEvent('$hideHud', player);
      TriggerEvent("pma-voice:updateVirtualWorld", player, 0)
      Player(player).state.turf_kills = 0;
      Player(player).state.turf_deaths = 0;
      vRPCturfs.endTurfWar(player, {turfId})
      vRPCturfs.setInTheTurf(player, {false})
      SetPlayerRoutingBucket(player, 0)
    end
  end
  turfs[turfId].faction = winner
  turfs[turfId].blipColor = vRP.getFactionBlip{winner}
  vRPCturfs.stopFlick(-1, {turfId})
  vRPCturfs.updateData(-1, {turfId, turfs[turfId].blipColor, winner})
  -- lastAttacked[turfWars[turfId].enemyFaction] = nil
  lastAttacked[turfWars[turfId].enemyFaction] = os.time()
  print(turfWars[turfId].enemyFaction)
  print(os.time())
  inWar[turfWars[turfId].allyFaction] = nil
  inWar[turfWars[turfId].enemyFaction] = nil
  turfWars[turfId] = nil
end

local factions = cfg.factions
AddEventHandler('onResourceStart',function(res)
  for i,v in pairs(factions) do
    lastAttacked[i] = 0
  end
end)

RegisterCommand("attack", function (player)
  if parseInt(os.date("%H")) >= plesTurfs.StartingHour and parseInt(os.date("%H")) <= plesTurfs.EndingHour then
    if isWarInThisDay(tostring(os.date("%A"))) then
      local user_id = vRP.getUserId{player}
      local faction = vRP.getUserFaction{user_id} or "Unknown"
      local fType = vRP.getFactionType{faction}
      if fType == "Mafie" or fType == "Gang" then
        if vRP.isFactionLeader{user_id, faction} then
            vRPCturfs.isPlayerInTurf(player, {0}, function (turfId)
              if turfId then
                if (turfs[turfId].faction == faction) then return vRPclient.notify(player, {plesTurfs.LangAllyTurfAttacked}) end
                
                local actTime = os.time()
                local remainingTime = (300 - (os.time() - lastAttacked[faction]))

                if (actTime - lastAttacked[faction]) < plesTurfs.AttackCooldown then return TriggerClientEvent("chatMessage",player,"^1[TURFS] ^0Asteapta ^3"..remainingTime.." secunde^0 pana sa ataci alt teritoriu!") end
                if inWar[turfs[turfId].faction] then return vRPclient.notify(player, {plesTurfs.LangEnemyAlreadyInWar}) end
                if inWar[faction] then return vRPclient.notify(player, {plesTurfs.LangAllyAlreadyInWar}) end
                if (turfs[turfId].faction == "Neocupat") then return(function ()
                  turfs[turfId].faction = faction
                  turfs[turfId].blipColor = vRP.getFactionBlip{faction}
                  exports[plesTurfs.databaseDriver]:execute("UPDATE " .. plesTurfs.database .. " SET faction = @faction WHERE id = @turfId", {
                    ["@turfId"] = turfId,
                    ["@faction"] = faction
                  })
                  vRPclient.notify(player, {plesTurfs.LangCaptureTurf})
                  vRPCturfs.updateData(-1, {turfId, turfs[turfId].blipColor, faction})
                end)() end
                local allyF = vRP.getOnlineUsersByFaction{faction} or {}
                if not (#allyF >= plesTurfs.onlineNeeded) then return vRPclient.notify(player, {plesTurfs.LangNoOnline}) end
                local enemyF = vRP.getOnlineUsersByFaction{turfs[turfId].faction} or {}
                if not (#enemyF >= plesTurfs.onlineNeeded) then return vRPclient.notify(player, {plesTurfs.LangNoOnlineEnemy}) end
                inWar[faction] = true
                inWar[turfs[turfId].faction] = true
                turfWars[turfId] = {
                  allyScore = 0,
                  enemyScore = 0,
                  allyFaction = turfs[turfId].faction,
                  enemyFaction = faction,
                  respawnCoords = {[turfs[turfId].faction] = vRP.getFactionCoords{turfs[turfId].faction}; [faction] = vRP.getFactionCoords{faction}},
                  warPlayers = {}
                }
                startTimer(plesTurfs.turfTimer, 0, turfId)
                Player(player).state.turf_kills = 0;
                Player(player).state.turf_deaths = 0;
                local flickTime, eBlip = plesTurfs.turfTimer * 60, vRP.getFactionBlip{turfWars[turfId].enemyFaction}
                local users = vRP.getUsers{}
                for uid, pl in pairs(users) do
                  local pfaction = vRP.getUserFaction{uid}
                  if pfaction == faction or pfaction == turfs[turfId].faction then
                    turfWars[turfId].warPlayers[uid] = {player = pl, faction = pfaction}
                    TriggerEvent("pma-voice:updateVirtualWorld", pl, turfId)
                    vRPCturfs.setInTheTurf(pl, {turfId})
                    vRPCturfs.drawTimer(pl, {turfWars[turfId].timer[1], turfWars[turfId].timer[2], turfId})
                    vRPCturfs.updateScore(pl, {turfWars[turfId].enemyScore, turfWars[turfId].allyScore, turfWars[turfId].enemyFaction, turfWars[turfId].allyFaction})
                    SetPlayerRoutingBucket(pl, turfId)
                  end
                end
                vRPCturfs.flickTurf(-1, {turfId, flickTime, eBlip, turfs[turfId].blipColor})
                TriggerClientEvent(plesTurfs.chatEvent, -1, string.format(plesTurfs.LangWarStarted, turfWars[turfId].enemyFaction, turfWars[turfId].allyFaction, turfId))
              else
                vRPclient.notify(player, {plesTurfs.LangNoTurf})
              end
            end)
        else
          vRPclient.notify(player, {plesTurfs.LangNoLeader})
        end
      else
        vRPclient.notify(player, {plesTurfs.LangNoMafia})
      end
    else
      vRPclient.notify(player, {plesTurfs.LangNoDay})
    end
  else
    vRPclient.notify(player, {plesTurfs.LangNoHour})
  end
end)

RegisterNetEvent("turfs:playerDied", function (killer)
  local killer = tonumber(killer)
  local killerId = vRP.getUserId{killer};
  if not killerId then return end;
  local player = source
  local user_id = vRP.getUserId{player}
  if not user_id then return end
  vRPCturfs.isPlayerInTurf(player, {0}, function (turfId)
    if not (turfId and turfWars[turfId] and turfWars[turfId].warPlayers[user_id]) then return end
    vRPCturfs.isInWarAndInComa(player, {}, function (InComa)
      if not InComa then return end
      Player(player).state.turf_deaths = (Player(player).state.turf_deaths or 0) + 1;
      local faction = turfWars[turfId].warPlayers[user_id].faction or vRP.getUserFaction{user_id}
      local killerFaction = turfWars[turfId].warPlayers[killerId].faction or vRP.getUserFaction{killerId}
      -- local faction = vRP.getUserFaction({user_id});
      if turfWars[turfId].allyFaction == faction then
        turfWars[turfId].enemyScore = turfWars[turfId].enemyScore + 1
      elseif turfWars[turfId].enemyFaction == faction then
        turfWars[turfId].allyScore = turfWars[turfId].allyScore + 1
      end
      local players = turfWars[turfId].warPlayers
      for user_id, data in pairs(players) do
        local pl = data.player
        if pl then
          vRPCturfs.updateScore(pl, {turfWars[turfId].enemyScore, turfWars[turfId].allyScore, turfWars[turfId].enemyFaction, turfWars[turfId].allyFaction})
          if killer and (turfWars[turfId].warPlayers[user_id].faction == killerFaction) then
            TriggerClientEvent("turfs:sendKillMessage", pl, GetPlayerName(killer), GetPlayerName(player), (GetSelectedPedWeapon((GetPlayerPed(killer)))), "win-log")
          else --[[if killer and (turfWars[turfId].warPlayers[user_id].faction == faction) then]]
            TriggerClientEvent("turfs:sendKillMessage", pl, GetPlayerName(killer), GetPlayerName(player), (GetSelectedPedWeapon((GetPlayerPed(killer)))), "lose-log")
          end
        end
      end
      if killer then
        Player(killer).state.turf_kills = (Player(killer).state.turf_kills or 0) + 1;
        vRPclient.notify(killer, {"~o~" .. GetPlayerName(killer) .. "~w~ L-a omorat pe ~o~" .. GetPlayerName(player) .. "~w~ Ai primit ~w~+" .. plesTurfs.healthOnKill .. " HP~w~"})
        vRPclient.varyHealth(killer, {plesTurfs.healthOnKill})
        if math.random(100) <= plesTurfs.armourChance then
          vRPclient.notify(killer, {"Ai primit ~y~+" .. plesTurfs.armourOnKill .. " Armura~w~ pentru ca l-ai omorat pe ~r~" .. GetPlayerName(player)})
          vRPCturfs.varyArmour(killer, {plesTurfs.armourOnKill})
        end
      end
      vRPCturfs.drawTimer(player, {turfWars[turfId].timer[1], turfWars[turfId].timer[2], turfId})
      local coords = turfWars[turfId].respawnCoords[faction] or vRP.getFactionCoords{faction}
      TriggerClientEvent("machiamavlad_turfs:respawnPlayer", player, coords[1], coords[2], coords[3], true)
    end)
  end)
end)

AddEventHandler("vRP:playerSpawn", function(user_id, source, first_spawn)
  if first_spawn then
      vRPSturfs.spawnTurfsC(source)
      Citizen.SetTimeout(1500, function()
          local faction = vRP.getUserFaction{user_id}
          local hasFaction = (faction ~= "user")
          
          if hasFaction then
              local foundWar = 0
              for turfId in pairs(turfs) do
                  if turfWars[turfId] then
                      if turfWars[turfId].allyFaction == faction or turfWars[turfId].enemyFaction == faction then
                          foundWar = turfId
                          break
                      end
                  end
              end
              
              if foundWar > 0 then
                  if turfWars[foundWar].warPlayers[user_id] == nil then
                      turfWars[foundWar].warPlayers[user_id] = {player = source, faction = faction}
                  end
                  
                  alreadyExecuted[source] = nil
                  vRPCturfs.setInTheTurf(source, {foundWar})
                  vRPCturfs.flickTurf(source, {foundWar, plesTurfs.turfTimer * 60, vRP.getFactionBlip{turfWars[foundWar].enemyFaction}, turfs[foundWar].blipColor})
                  vRPCturfs.drawTimer(source, {turfWars[foundWar].timer[1], turfWars[foundWar].timer[2], foundWar})
                  vRPCturfs.updateScore(source, {
                      turfWars[foundWar].enemyScore,
                      turfWars[foundWar].allyScore,
                      turfWars[foundWar].enemyFaction,
                      turfWars[foundWar].allyFaction,
                  })
                  TriggerEvent("pma-voice:updateVirtualWorld", source, foundWar)
                  TriggerClientEvent("chatMessage", source, "^1Turfs | ^0Ai fost mutat in ^1Virtual World^0 deoarece mafia ta se afla intr-un ^1war^0!")
                  Player(source).state.turf_kills = 0;
                  Player(source).state.turf_deaths = 0;
                  SetPlayerRoutingBucket(source, foundWar)
              end
          end
      end)
  end
end)

AddEventHandler("vRP:playerLeave", function(user_id, player)
  local hasFaction = vRP.hasUserFaction({user_id})
  if hasFaction then
      local theFaction = vRP.getUserFaction({user_id})
      local ftype = vRP.getFactionType{theFaction}
      if ftype ~= "Mafie" then return end
      for k, v in pairs(turfs) do
          local turfID = k
          if turfWars[turfID] then
              if turfWars[turfID].warPlayers[user_id] then
                  turfWars[turfID].warPlayers[user_id] = nil;
                  break
              end
          end
      end
  end
end)

CreateThread(function() vRPSturfs.spawnTurfs() Wait(3000) vRPSturfs.spawnTurfsC(-1) end)